package storage

import (
	"context"
	"os"
	"testing"

	. "my/ktgo/pkg/testlib"

	"github.com/cucumber/godog"
	"github.com/cucumber/godog/colors"

	. "github.com/onsi/gomega"
)

func InitializeScenario(ctx *godog.ScenarioContext) {
	ctx.Step(`^Файл со списком:$`, файлСоСписком)
	ctx.Step(`^Хранилище$`, хранилище)
	ctx.Step(`^В буфере строк: (\d+)$`, вБуфереСтрок)
	ctx.Step(`^В файл дописывается строка "([^"]*)"$`, вФайлДописываетсяСтрока)

	// -----------------------
	ctx.Before(func(ctx context.Context, sc *godog.Scenario) (context.Context, error) {
		beforeScenario()
		return ctx, nil
	})
	ctx.After(func(ctx context.Context, sc *godog.Scenario, err error) (context.Context, error) {
		afterScenario()
		return ctx, nil
	})
	InitializeGomegaForGodog(ctx)
	_ = Ω
}

func InitializeSuite(tsc *godog.TestSuiteContext) {
	tsc.BeforeSuite(beforeSuite)
	tsc.AfterSuite(afterSuite)
}

func TestMain(t *testing.T) {
	var opts = godog.Options{
		Output:        colors.Colored(os.Stdout),
		Strict:        true,
		StopOnFailure: true,
		TestingT:      t,
	}

	godog.BindCommandLineFlags("godog.", &opts)
	godog.TestSuite{
		Name:                 "app",
		TestSuiteInitializer: InitializeSuite,
		ScenarioInitializer:  InitializeScenario,
		Options:              &opts,
	}.Run()
}
