package storage

import (
	"my/ktgo/pkg/lib"
	. "my/ktgo/pkg/testlib"
	"os"
	"time"

	"github.com/cucumber/godog"
	. "github.com/onsi/gomega"
)

const (
	TestStorageFileName = "/tmp/test_storage.txt"
)

type testData struct {
	storage *Storage
}

var (
	t *testData
)

func resetTestData() {
	t = &testData{}
}

func beforeSuite() {
	_ = Ω
}
func afterSuite() {
}

func beforeScenario() {
	resetTestData()
}
func afterScenario() {
	os.RemoveAll(TestStorageFileName)
}

// -----------------------
func файлСоСписком(in *godog.DocString) {
	err := lib.WriteFile(TestStorageFileName, in.Content)
	Ok(err)
}
func хранилище() {
	s, err := NewStorage(TestStorageFileName)
	Ok(err)
	t.storage = s
	time.Sleep(10 * time.Millisecond)
}
func вБуфереСтрок(кво int) {
	_, err := lib.ReadFile(TestStorageFileName)
	Ok(err)

	// println("---content---")
	// print(content)
	// println("---content---")

	Ω(*t.storage.GetList()).To(HaveLen(кво), "GetList")
}
func вФайлДописываетсяСтрока(s string) {
	err := lib.AppendToFile(TestStorageFileName, s+"\n")
	Ok(err)
	time.Sleep(10 * time.Millisecond)
}
